import UIKit
import Flutter

@UIApplicationMain
@objc class AppDelegate: FlutterAppDelegate {
  override func application(
    _ application: UIApplication,
    didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?
  ) -> Bool {
    GeneratedPluginRegistrant.register(with: self)
    
    let controller : FlutterViewController = window?.rootViewController as! FlutterViewController;
    let messageChannel = FlutterBasicMessageChannel.init(name: "com.sicilyliu", binaryMessenger: controller.binaryMessenger);
    
    messageChannel.setMessageHandler({
        (message: Any, callback: FlutterReply) -> Void in
        let mess : NSDictionary = message as! NSDictionary;
        let method : NSString = mess.object(forKey:"method") as! NSString;
//        let method = String(describing: mess["method"]);
        if (method == "getTime") {
            let dic = NSMutableDictionary.init(dictionary:["code":mess["code"], "message":mess["message"]]);
            messageChannel.sendMessage(dic);
        }
        else if (method == "battery") {
            receiveBatteryLevel(result: callback);
        }
        else if (method == "hello") {
            let dic = NSMutableDictionary.init(dictionary:["code":mess["code"], "message":mess["message"]]);
            callback(dic);
        }
        else {
        }
    });
    
    return super.application(application, didFinishLaunchingWithOptions: launchOptions)
  }
}


private func receiveBatteryLevel(result: FlutterReply) {
    let device = UIDevice.current;
    device.isBatteryMonitoringEnabled = true;
    if (device.batteryState == UIDevice.BatteryState.unknown) {
        result(FlutterError.init(code: "UnAvailable", message: "电池信息不可用", details: nil));
    }
    else {
        result(Int(device.batteryLevel * 100));
    }
}
